package jp.gr.java_conf.coskx.testmydialog;

import androidx.appcompat.app.AppCompatActivity;

import android.content.DialogInterface;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;

import androidx.fragment.app.FragmentManager;

public class MainActivity extends AppCompatActivity {

    private final String TAG = "coskx:MainActivity";
    private myDialogClass mmyDialogClass = null;
    private FragmentManager fragmentManager;
    private String mString = "Hello world! Dialog Test";


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Log.i(TAG,"onCreate()");
        setContentView(R.layout.activity_main);
        Button button = findViewById(R.id.ID_ButtonGo);

        fragmentManager = getSupportFragmentManager();
        setReadyMyDialog();

        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Log.i(TAG,"button onClick");
                //ダイアログを表示する
                showMyDialog(fragmentManager);
            }
        });
    }

    @Override
    protected void onStart() {
        super.onStart();
        Log.i(TAG,"onStart()");
    }

    @Override
    public void onStop() {
        super.onStop();
        Log.i(TAG,"onStop()");
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        Log.i(TAG,"onDestroy()");
    }

    @Override
    protected void onResume() {
        super.onResume();
        Log.i(TAG,"onResume()");
    }

    private void setReadyMyDialog() {
        if (mmyDialogClass != null) return;
        Log.i(TAG,"setReadyTestDialog()");
        mmyDialogClass = myDialogClass.newInstance();
        mmyDialogClass.setOnClickListener(new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                Log.i(TAG,"onClick work started");
                if (which == 0) {
                    mString = mmyDialogClass.getText();
                    Toast.makeText(MainActivity.this, "[OK] clicked. mString = [" + mString + "]", Toast.LENGTH_LONG).show();
                } else {
                    Toast.makeText( MainActivity.this, "[Cancel] clicked.", Toast.LENGTH_LONG).show();
                }
                Log.i(TAG,"onClick work completed");
            }
        });
    }

    private void showMyDialog(FragmentManager manager) {
        Log.i(TAG,"showMyDialog()");
        mmyDialogClass.setText(mString);
        mmyDialogClass.show(manager);
    }

}