package jp.gr.java_conf.coskx.testmydialog;

import android.app.Dialog;
import android.content.DialogInterface;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.EditText;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.DialogFragment;
import androidx.fragment.app.FragmentManager;

public class myDialogClass extends DialogFragment {
    private static final String TAG = "coskx:myDialogClass";

    private Dialog mDialog;
    //これはstaticでなくてOK
    private static DialogInterface.OnClickListener ClickListener = null;
    //　これは　画面回転などで再構築された際にそのまま動作するためには static でなければならない

    private boolean busy = false;
    private EditText mEditText; //[sec]
    private static String mString;
    //　これは　画面回転などで再構築された際にそのまま動作するためには static でなければならない

    //インスタンス作成時に呼ばれる
    public static myDialogClass newInstance() {
        Log.i(TAG,"newInstance()");
        myDialogClass mmyDialogClass = new myDialogClass();
        return mmyDialogClass;
    }

    public myDialogClass() {
        Log.i(TAG,"myDialogClass() [constructor]");
        busy = false;
    }

    //private Window MyWindow;

    @Override
    //show()のとき実行される　これが最初に呼ばれる
    public Dialog onCreateDialog(Bundle savedInstanceState) {

        Log.i(TAG,"onCreateDialog()");

        mDialog = new Dialog(getActivity());
        mDialog.setContentView(R.layout.dialog_test);

        //ダイアログの外部にタップしてもcancelにならない
        this.setCancelable(false);

        final Button btnpositive = mDialog.findViewById(R.id.ID_Positive_Button);
        final Button btnnegative = mDialog.findViewById(R.id.ID_Negative_Button);
        mEditText = mDialog.findViewById(R.id.ID_EditText);
        mEditText.setText(mString);

        // OK ボタンのリスナ
        btnpositive.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Log.i(TAG,"onClick positive button work started");
                mString = mEditText.getText().toString();
                Log.i(TAG,"onClick positive button work [ClickListener = " + ClickListener.toString() + "]");
                ClickListener.onClick(mDialog, 0);
                dismiss(); //これがないと消えない
                Log.i(TAG,"onClick positive button work completed");
            }
        });
        // Close ボタンのリスナ
        btnnegative.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Log.i(TAG,"onClick cancel button work started");
                Log.i(TAG,"onClick cancel button work [ClickListener = " + ClickListener.toString() + "]");
                ClickListener.onClick(mDialog,1);
                dismiss(); //これがないと消えない
                Log.i(TAG,"onClick cancel button work completed");
            }
        });

        //*
        //サイズの最適化　途中でデバイスが縦位置から横位置になってもそれなりに表示される
        WindowManager.LayoutParams lp = mDialog.getWindow().getAttributes();
        DisplayMetrics metrics = getResources().getDisplayMetrics();
        int dialogWidth = (int) (metrics.widthPixels);
        //int dialogHeight = (int) (metrics.heightPixels);
        lp.width = dialogWidth;
        //lp.height = dialogHeight;
        mDialog.getWindow().setAttributes(lp);
        //*/

        return mDialog;
    }

    //これはdeprecated
    /*
    @Override
    //show()のとき実行される　onCreateDialogの次に呼ばれる
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);
        Log.i(TAG,"onActivityCreated");
    }
    */
    
    @Nullable
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container,
                             @Nullable Bundle savedInstanceState) {
        // フィールドにレイアウトIDが保存されている場合は inflate して返す。
        // 0 は未指定を意味する。
        //if (mContentLayoutId != 0) {
        //    return inflater.inflate(mContentLayoutId, container, false);
        //}
        Log.i(TAG,"onCreateView()");
        return null;
    }

    @Override
    public void onViewCreated(View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        Log.i(TAG,"onViewCreated()");
    }

    //Dismiss()直後に呼ばれる
    @Override
    public void onDismiss(DialogInterface dialogif) {
        Log.i(TAG,"onDismiss()");
        super.onDismiss(dialogif);
    }

    //dismiss後，onDestroyView()より前に呼ばれる
    @Override
    public void onStop() {
        Log.i(TAG,"onStop()");
        super.onStop();
    }

    //dismiss後，最後に呼ばれる ダイアログ本体はこれで閉じられたことが判る
    @Override
    public void onDestroyView() {
        Log.i(TAG,"onDestroyView()");
        super.onDestroyView();
        busy = false;
    }

    //クリックリスナーの登録
    public void setOnClickListener(DialogInterface.OnClickListener listener) {
        Log.i(TAG,"setOnClickListener() [okClickListener = " + listener + "]");
        ClickListener = listener;
    }

    public void setText(String in) {
        Log.i(TAG,"setText()");
        mString=in;
        //mEditText.setText(mString); show()のときにdialogが作られるので
        //ここではdialogの実体に書き込めないので変数に保存するのみ
        //onCreateDialogでdialogの実体に書き込んでもらう
    }

    public String getText() {
        Log.i(TAG,"getText()");
        return mString;
    }

    public void show(FragmentManager manager) {
        if (busy) return;
        busy = true;
        Log.i(TAG,"show()");
        show(manager, "dialog_fragmentXX");
    }
}
